import es, playerlib, popuplib, gamethread, os, string

info = es.AddonInfo() 
info['name']        = "JT cal menu" 
info['version']     = "0.3" 
info['author']      = "JT aka joshtrav" 
info['description'] = "Menu to set up cal matches for all members" 

cal_admins = (
	'STEAM_0:0:14162563', #whip
	'STEAM_0:0:12341389', #woot
	'STEAM_0:1:12845687', #nitrous
	'STEAM_0:1:15610822', #jt
	'STEAM_0:0:2009061',  #gobi
	'STEAM_0:0:13142483', #beaver
	'STEAM_0:1:265067',   #topdog
	'STEAM_0:1:9844026',  #pike
	'STEAM_0:1:42490',    #scurvey
	'STEAM_0:0:5490600',  #scurvey2
	'STEAM_0:0:6592310',  #DM
	'STEAM_0:1:11310697', #Brutality
	'STEAM_0:0:15659503', #joemama
	'STEAM_0:0:11673127', #tex
	'STEAM_0:0:15159094', #buddah
	'STEAM_0:1:9472353',  #pain
	'STEAM_0:1:15085775', #crayola
	'STEAM_0:1:1476230',  #spectral
	'STEAM_0:0:12160233', #longboardr
	'STEAM_0:1:11704716', #budda
	'STEAM_0:0:15055352', #raiders
	'STEAM_0:1:17290935', #weeder
	'STEAM_0:0:11810295', #yoshi
	'STEAM_0:0:9965914',  #mudkips
	'STEAM_0:0:15769641', #neto
	'STEAM_0:0:11031112', #evo
	'STEAM_0:0:12635012', #infero
	'STEAM_0:0:16532053', #wolfe
	'STEAM_0:1:6545167',  #saint
	'STEAM_0:0:17291118', #zeitzef
	'STEAM_0:1:5976931',  #cold-steel
	'STEAM_0:0:9690728',  #legacy
)

jtcal_team_dict = {}
# Thanks superdave for the map returns
# Thanks bonbon for the esc menu info
# Thanks jeff for letting me bug the crap out of you as always


def load():
	if not es.exists('clientcommand', 'calmenu'):
		es.regclientcmd('calmenu', 'jtcal/run_calmenu', 'none')
	if not es.exists('clientcommand', '!calmenu'):
		es.regclientcmd('!calmenu', 'jtcal/run_calmenu', 'none')
	if not es.exists('saycommand', 'calmenu'):
		es.regsaycmd('calmenu', 'jtcal/run_calmenu', 'none')
	if not es.exists('saycommand', '!calmenu'):
		es.regsaycmd('!calmenu', 'jtcal/run_calmenu', 'none')
	if not es.exists('clientcommand','CAL_pass_choice2'):
		es.regclientcmd('CAL_pass_choice2','jtcal/CAL_pass_chosen','none') 
	calmenu = popuplib.easymenu('CAL Menu', '_popup_choice', CAL_menu_select)
	calscriptmenu = popuplib.easymenu('Choose Script', '_popup_choice',calscript_select)
	calpassmenu = popuplib.easymenu('Set Password', '_popup_choice',calpass_select)
	calalltalkmenu = popuplib.easymenu('All talk options', '_popup_choice',calalltalk_select)
	calplayermenu = popuplib.easymenu('Player options', '_popup_choice',calplayer_select)
	calmapmenu = popuplib.easymenu('Choose a map', '_popup_choice',calmap_select)
	calmenu.addoption('Choose Script','Run a script')
	calmenu.addoption('Set Password','Server Password')
	calmenu.addoption('All talk options','All talk options')
	calmenu.addoption('Player options','Player options')
	calmenu.addoption('Choose a map','Change the map')
	calplayermenu.addoption('team_swap','Switch Teams')
	calplayermenu.addoption('player_kick','Kick player')
	calscriptmenu.addoption('cal_default','Default Server')
	calscriptmenu.addoption('cal_cal','CAL Script')
	calscriptmenu.addoption('cal_ot','CAL OT Script')
	calscriptmenu.addoption('cal_crash','CAL Crash Script')
	calpassmenu.addoption('cal_pass','Password Server')
	calpassmenu.addoption('cal_nopass','Remove Password')
	calalltalkmenu.addoption('cal_talkon','Turn All Talk on')
	calalltalkmenu.addoption('cal_talkoff','Turn All Talk off')
	maps = returnMaps('maplist.txt') 
	for map in maps:
		calmapmenu.addoption(map, map)

def calplayer_select(userid, choice, popupid):
	if choice == 'player_kick':
		cal_kick_1(userid)
	elif choice == 'team_swap':
		for cal_team_id in playerlib.getUseridList('#all'):
			if playerlib.getPlayer(cal_team_id).get('teamid') == 2:
				es.server.queuecmd('est_team %s 3'%cal_team_id)
			elif playerlib.getPlayer(cal_team_id).get('teamid') == 3:
				es.server.queuecmd('est_team %s 2'%cal_team_id)
		es.server.queuecmd('mp_restartgame 1')
		es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Teams swapped, restarting in 1 second.')

def CAL_menu_select(userid, choice, popupid):	
	popuplib.send(choice, userid)
	
def cal_kick_1(userid):
	players = popuplib.construct('TargetMenu', 'players', '#all')
	players.settitle('Choose a player')
	players.menuselectfb = cal_kick_2
	players.send(userid)
	
def calmap_select(userid, choice, popupid):
	es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Changing map to %s in 2 seconds.'%choice)
	es.server.queuecmd('es_delayed 2 changelevel %s'%choice)
	
def cal_kick_2(userid, choice, popupid):
	cal_kick_id = choice
	cal_kick_name = playerlib.getPlayer(cal_kick_id).get('name')
	es.server.queuecmd('es_delayed 2 kick %s'%cal_kick_name)
	es.tell(userid, '#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Kicking %s in 2 seconds.'%cal_kick_name)

def run_calmenu():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	if steamid in cal_admins:
		popuplib.send('CAL Menu', userid)
	else:
		es.tell(userid, '#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Your not on the list.')

def round_end(ev):
	global jtcal_team_dict
	if jtcal_team_dict.has_key('status'):
		if jtcal_team_dict['status']:
			if int(ev['winner']) == 2:
				if not jtcal_team_dict.has_key('t'):
					jtcal_team_dict['t'] = 1
				else:
					jtcal_team_dict['t'] += 1
			elif int(ev['winner']) == 3:
				if not jtcal_team_dict.has_key('ct'):
					jtcal_team_dict['ct'] = 1
				else:
					jtcal_team_dict['ct'] += 1
		
def calscript_select(userid, choice, popupid):
	global jtcal_team_dict
	if choice == 'cal_default':
		es.server.queuecmd('es_delayed 2 exec server.cfg')
		jtcal_team_dict.clear()
	elif choice == 'cal_cal':
		es.server.queuecmd('es_delayed 2 exec lo3cpl.cfg')
		jtcal_team_dict['status'] = 1
	elif choice == 'cal_ot':
		es.server.queuecmd('es_delayed 2 exec lo3cpl_ot.cfg')
	elif choice == 'cal_crash':
		es.server.queuecmd('es_delayed 2 exec lo3cpl_crash.cfg')
	es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Loading config in 2 seconds.')
	
def calpass_select(userid, choice, popupid):	
	if choice == 'cal_pass':
		CAL_pass_choice(userid)
	elif choice == 'cal_nopass':
		es.server.queuecmd('sv_password none')
		es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- The password has been removed.')

def calalltalk_select(userid, choice, popupid):	
	if choice == 'cal_talkon':
		es.server.queuecmd('sv_alltalk 1')
		es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- All Talk has been enabled.')
	elif choice == 'cal_talkoff':
		es.server.queuecmd('sv_alltalk 0')
		es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- All Talk has been disabled.')

def CAL_pass_choice(userid):
	es.escinputbox(30, userid, 'CAL Match by JT', 'Enter a password', 'CAL_pass_choice2')
	es.tell(userid, '#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Press escape on your keyboard to input a password.')

def CAL_pass_chosen():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	if steamid in cal_admins:
		cal_new_pass = es.getargv(1) 
		es.server.queuecmd('sv_password "%s"'%cal_new_pass)
		es.tell(userid, '#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Password is now set to: #green%s.'%cal_new_pass)
		
def round_start(ev):
	global jtcal_team_dict
	if jtcal_team_dict.has_key('status'):
		if jtcal_team_dict['status'] == 1:
			if jtcal_team_dict.has_key('t'):
				announce_t = jtcal_team_dict['t']
			else:
				announce_t = 0
				jtcal_team_dict['t'] = 0
			if jtcal_team_dict.has_key('ct'):
				announce_ct = jtcal_team_dict['ct']
			else:
				announce_ct = 0
				jtcal_team_dict['ct'] = 0
			announce_total = announce_ct + announce_t
			if announce_total == 12:
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists: #green%s#default, CT: #green%s#default, Round #green%s#default of #green24'%(announce_t,announce_ct,announce_total + 1))
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Midway point.  Swapping teams and reloading config in 5 seconds.')
				jtcal_team_dict['status'] = 2
				gamethread.delayed(3,cal_match_mid)
			else:
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists: #green%s#default, CT: #green%s#default, Round #green%s#default of #green24'%(announce_t,announce_ct,announce_total + 1))
		elif jtcal_team_dict['status'] == 2:
			announce_t = jtcal_team_dict['t']
			announce_ct = jtcal_team_dict['ct']
			announce_total = announce_ct + announce_t
			if announce_t == 13:
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists: #green%s#default, CT: #green%s#default, Match Over'%(announce_t,announce_ct))
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists have won.  Running default config and removing password in 5 seconds.')
				gamethread.delayed(5,cal_match_end)
				jtcal_team_dict.clear()
			elif announce_ct == 13:
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists: #green%s#default, CT: #green%s#default, Match Over'%(announce_t,announce_ct))
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- CTs have won.  Running default config and removing password in 5 seconds.')
				gamethread.delayed(5,cal_match_end)
				jtcal_team_dict.clear()
			elif announce_total < 24:
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists: #green%s#default, CT: #green%s#default, Round #green%s#default of #green24'%(announce_t,announce_ct,announce_total + 1))
			elif announce_total == 24:
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Terrorists: #green%s#default, CT: #green%s#default, Match Over'%(announce_t,announce_ct))
				es.msg('#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Match a tie.  Running default config and removing password in 5 seconds.')
				gamethread.delayed(5,cal_match_end)
				jtcal_team_dict.clear()
	else:
		for cal_player in playerlib.getUseridList('#all'):
			steamid = playerlib.getPlayer(cal_player).get('steamid')
			if steamid in cal_admins:
				es.tell(cal_player, '#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Type calmenu or !calmenu to set up the server.')
				es.tell(cal_player, '#multi', '#lightgreen[#greenJT\'s CAL admin#lightgreen] #default- Please run default config and remove password once your done!')
			
def returnMaps(map_path):
	mfile = open(es.ServerVar('eventscripts_gamedir') + '/' + map_path)
	maps = filter(lambda x: es.exists('map', x), map(string.strip, mfile.readlines()))
	mfile.close()
	return maps
	
def cal_match_mid():
	global jtcal_team_dict
	for cal_team_id in playerlib.getUseridList('#all'):
		if playerlib.getPlayer(cal_team_id).get('teamid') == 2:
			es.server.queuecmd('est_team %s 3'%cal_team_id)
		elif playerlib.getPlayer(cal_team_id).get('teamid') == 3:
			es.server.queuecmd('est_team %s 2'%cal_team_id)
	Swap_t = int(jtcal_team_dict['t'])
	Swap_ct = int(jtcal_team_dict['ct'])
	jtcal_team_dict['t'] = int(Swap_ct)
	jtcal_team_dict['ct'] = int(Swap_t)
	es.server.queuecmd('es_delayed 2 exec lo3cpl.cfg')
	
def cal_match_end():
	global jtcal_team_dict
	jtcal_team_dict.clear()
	es.server.queuecmd('exec server.cfg')
	es.server.queuecmd('es_delayed 2 sv_password none')
	
	
	
	